#include "mytime.h"
#include <time.h>
#include <stdlib.h>
#ifdef WIN32
  #include <windows.h>
#endif

struct tm *getLocalTime(time_t *when)
{
  struct tm *mytime;

  if (when == NULL)
  {
    when = malloc(sizeof(time_t));
    *when = time((time_t *)NULL);
  }
  
#ifndef WIN32
  mytime = (struct tm *)malloc(sizeof(struct tm));
  localtime_r(when, mytime);
#else
  mytime = localtime(when);
#endif
  return mytime;
}

int getHour()
{
  struct tm *mytime;
  int hour = 0;

  mytime = getLocalTime((time_t *)NULL);
  hour = mytime->tm_hour;
  return hour;
}

#ifndef WIN32
char *getDayName(time_t when)
{
  struct tm *mytime;
  char *dayName;

  mytime = getLocalTime(&when);
  dayName = (char *)calloc(20, 1); /* Large vision! */
  strftime(dayName, 20, "%A", mytime);
  return dayName;
}
#else
void UnixTimeToFileTime(time_t t, LPFILETIME pft)
{
  LONGLONG ll;

  ll = Int32x32To64(t, 10000000) + 116444736000000000;
  pft->dwLowDateTime = (DWORD)ll;
  pft->dwHighDateTime = ll >> 32;
}

void UnixTimeToSystemTime(time_t t, LPSYSTEMTIME pst)
{
  FILETIME ft;

  UnixTimeToFileTime(t, &ft);
  FileTimeToSystemTime(&ft, pst);
}

char *getDayName(time_t when)
{
  SYSTEMTIME Time;
  char *dayName;
  
  /* GetLocalTime(&Time); */
  UnixTimeToSystemTime(when, &Time);
  dayName = (char *)malloc(20);
  if (GetDateFormat(LOCALE_USER_DEFAULT, 0, &Time, "dddd", dayName, 20) == 0)
  {
    printf("Error in GetDateFormat.\n");
    return NULL;
  }
  return dayName;
}
#endif

int getMinute()
{
  struct tm *mytime;
  int min = 0;

  mytime = getLocalTime((time_t *)NULL);
  min = mytime->tm_min;
  return min;
}

int getYear()
{
  struct tm *mytime;
  int year = 0;

  mytime = getLocalTime((time_t *)NULL);
  year = mytime->tm_year;
  return year;
}

int getMonth()
{
  struct tm *mytime;
  int month = 0;

  mytime = getLocalTime((time_t *)NULL);
  month = mytime->tm_mon;
  return month;
}
